import { TestBed,ComponentFixture,async } from '@angular/core/testing';
import { By } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { WjGridModule , WjFlexGrid } from '@grapecity/wijmo.angular2.grid';
import {DebugElement} from "@angular/core";
describe('AppComponent', () => {
  let appComponent: ComponentFixture<AppComponent>;
  let appComDebugElement: DebugElement;
  let myComponent: AppComponent;
  let myNativeElement: Element;
  let gridDebugElement: DebugElement;
  let grid: WjFlexGrid;
  let gridNativeElement: HTMLElement;

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      declarations: [
        AppComponent
      ],
      imports:[
        WjGridModule
      ]
    }).compileComponents();

    appComponent = TestBed.createComponent(AppComponent);
    appComDebugElement = appComponent.debugElement;
    myComponent = appComDebugElement.componentInstance;
    myNativeElement = appComDebugElement.nativeElement as Element;
    gridDebugElement = appComDebugElement.query(By.directive(WjFlexGrid));
    gridNativeElement = gridDebugElement.nativeElement;
    grid = gridDebugElement.componentInstance;
    gridNativeElement = gridDebugElement.nativeElement;
    appComponent.detectChanges();
  });

  it('should create the app', () => {
    const fixture = TestBed.createComponent(AppComponent);
    const app = fixture.componentInstance;
    expect(app).toBeTruthy();
  });

  it(`should have as title 'wijmo-start'`, () => {
    const fixture = TestBed.createComponent(AppComponent);
    const app = fixture.componentInstance;
    expect(app.title).toEqual('wijmo-start');
  });

  it('should render title', () => {
    const fixture = TestBed.createComponent(AppComponent);
    fixture.detectChanges();
    const compiled = fixture.nativeElement as HTMLElement;
    expect(compiled.querySelector('.content span')?.textContent).toContain('wijmo-start app is running!');
  });

  it(`should display the "Id" column header`, async(() => {
    const colHeaderCellElement: Element | null = gridNativeElement.querySelectorAll('.wj-colheaders .wj-cell.wj-header')[0];
    expect(colHeaderCellElement).not.toBeNull();
    if (colHeaderCellElement) {
        expect(colHeaderCellElement.textContent).toEqual('Id');
    }
  }));
  it(`should render the first country cell is "US" `, async(() => {
    const countryCellElement: Element | null = gridNativeElement.querySelectorAll('.wj-cells .wj-cell')[1];
    expect(countryCellElement).not.toBeNull();
    if (countryCellElement) {
        expect(countryCellElement.textContent).toEqual('US');
    }
  }));  

  it('should fire selectionChanged event', async(() => {
    appComponent.detectChanges();
    spyOn(myComponent, 'selectionChanged');
    grid.select(2, 2);
    expect(myComponent.selectionChanged).toHaveBeenCalled();
    appComponent.detectChanges();
}));
});
